<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>EDMA (Enhanced DMA) Driver</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">EDMA (Enhanced DMA) Driver </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="intro_sec"></a>
Introduction</h1>
<p>The EDMA IP in the ARxxxx SoCs can be programmed at a high-level using the EDMA driver software that allows hook-up with an operating system. The EDMA driver exposes programming of most features provided by the IP. Although the EDMA's user guide for ARxxxx SoCs is not available at present on the TI public web, because this IP is used in many other older TI parts, it can be referred to for example at the following url: <a href="http://www.ti.com/lit/ug/sprugs5b/sprugs5b.pdf">http://www.ti.com/lit/ug/sprugs5b/sprugs5b.pdf</a></p>
<p>Following is a high level description of the APIs/features:</p>
<ul>
<li>Query number of EDMA instances on the SoC.</li>
<li>Initialize a particular instance of EDMA to a known clean disabled state (a reset like state).</li>
<li>Open an instance of EDMA, which returns instance information such as number of transfer controllers on that instance.</li>
<li>Configure a channel to desired configuration and optionally enable channel. This includes PaRAM set choice and PaRAM set configuration. User can optionally supply call-back function for channel transfer completion indication.</li>
<li>Enable/disable a channel.</li>
<li>Configure a PaRAM set. Typically useful for linked PaRAMs.</li>
<li>Link PaRAM sets.</li>
<li>Chain channels.</li>
<li>Start transfer (manually-triggered) of a previously configured channel.</li>
<li>Wait until transfer is complete (used in the case when call-back in configuration is not provided).</li>
<li>APIs to set source or destination address of a PaRAM set, intended for some use cases on XWR16XX (DSP).</li>
<li>Error generation from CC (Channel Controller) and all TCs (Transfer Controllers).</li>
<li>Status query.</li>
<li>Performance control.</li>
<li>Close an instance of EDMA.</li>
</ul>
<p>Here a channel can be a DMA or QDMA channel.</p>
<h1><a class="anchor" id="limit"></a>
Limitations</h1>
<h2><a class="anchor" id="hwlimit"></a>
Unsupported Hardware features.</h2>
<p>Following features of the EDMA hardware are presently NOT supported:</p><ul>
<li>Programming of privilege level and privilege ID is not provided, these are assumed to be always highest privilege (default settings).</li>
<li>Querying of source active registers and destination FIFO register in EDMA TC (Transfer Controller) for advanced debugging not supported.</li>
</ul>
<h2><a class="anchor" id="swlimit"></a>
Unsupported Software features.</h2>
<ul>
<li>No resource management of any sort is provided e.g no DMA or QDMA channel resource management. User is required to do static or dynamic resource management outside of the driver. On XWR16xx, the driver software does not prevent both (R4F and C674) processors from operating the same physical EDMA instance, software instances are not shared among the processors (software instances are in local memories of processors). However, if both processors wish to operate on the same physical instance, then they must coordinate their activities outside the driver (say using mailbox messages) to ensure only one is operating on the same physical instance at a time (because read-modify-write operations would become inconsistent without multi-processor semaphores) and also coordinate resource management for resources like channels and transfer completion codes. On XWR16xx, R4F is only allowed to program physical instance 0, the C674 can program both instance 0 and 1. So overlap is only possible for physical instance 0.</li>
</ul>
<h1><a class="anchor" id="api"></a>
API</h1>
<p>The EDMA API header file should be included in an application as follows: </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;<a class="code" href="edma_8h.html">ti/drivers/edma/edma.h</a>&gt;</span></div></div><!-- fragment --><p>The documentation for all APIs can be referred by clicking at above file or by going to <a class="el" href="group___e_d_m_a___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html">EDMA Driver External Functions</a>. Example usage of the EDMA driver can be seen by referring to the EDMA unit test code located at </p><pre class="fragment">ti/drivers/edma/test/ti_rtos/main.c </pre><h1><a class="anchor" id="event"></a>
EDMA Event Mapping Definitions.</h1>
<p>Event mapping definitions for the 64 DMA channels can be referred to in the files:</p><pre class="fragment">ti/common/sys_common_*.h </pre><p> with names: </p><pre class="fragment">*_REQ_* </pre><p> For example (on XWR14xx):</p><pre class="fragment">#define EDMA_TPCC0_REQ_HWACC_0     (17U) </pre><p> indicates that for instance 0 (CC0) of the EDMA, event number 17 (0-based) is tied to Hardware Accelerator's channel 0 in the SoC. During programming the channelId parameter when calling configuration API, these defines can be used depending on what is desired e.g the above example define when used means that when the Hardware Accelerator channel 0 output line fires, it will trigger the EDMA channel 17 that was configured using this define. Note the unit test code may not illustrate this because it picks particular numbers to test certain boundary conditions.</p>
<p>Channels that are not tied to any hardware event are available for general usage (e.g for chaining purposes), these channels are marked with the suffix:</p><pre class="fragment">FREE_&lt;n&gt; </pre><p> For example:</p><pre class="fragment">EDMA_TPCC0_REQ_FREE_0 </pre><h1><a class="anchor" id="caution"></a>
Caution</h1>
<p>It may be important to disable channels after transfers are done. One case is: A QDMA channel with param X was programmed and transfer completed with a trigger word. Then the same param X that is associated with a DMA channel is used for the DMA channel configuration because it is free. When configure API is issued, it will only deal with DMA channel registers as the channel type is DMA and will leave the QDMA channel untouched (in this case enabled). When the param is configured for this DMA channel, it will prematurely trigger the QDMA channel when the trigger word that was left armed is attempted to be configured. Disabling the QDMA channel before the param associated with it is reused will prevent the problem.</p>
<h1><a class="anchor" id="mem_footprint"></a>
Memory Footprint</h1>
<p>The memory footprint of the driver depends on how many APIs are referred to by an application (all are not necessary for basic operation). The unit test code's generated memory map file may be used to get an estimate of the memory foot-print when most APIs are used. </p>
</div></div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
